#ifndef __i8090_H__
#define __i8090_H__

#ifdef WINCONSDK_EXPORTS
#define WINCONSDK_API extern "C" __declspec(dllexport)
#else
#define WINCONSDK_API extern "C" __declspec(dllimport)
#endif

//-------------- define parameter ----------------------------------
#define YES    1
#define NO     0
#define ON     1
#define OFF    0 

#define X_axis          1
#define Y_axis          2
#define Z_axis          3

#define ENC_QUADRANT    0x00
#define ENC_CW_CCW      0x10
#define ENC_PULSE_DIR   0x20

//-------------- subroutines --------------------------------------- 
WINCONSDK_API unsigned char i8090_REGISTRATION(unsigned char cardNo, int slot);
WINCONSDK_API void          i8090_INIT_CARD(unsigned char cardNo,
										unsigned char x_mode,
										unsigned char y_mode,
										unsigned char z_mode);
WINCONSDK_API unsigned short int  i8090_GET_ENCODER(unsigned char cardNo, unsigned char axis);
WINCONSDK_API void				  i8090_RESET_ENCODER(unsigned char cardNo, unsigned char axis);
//-------------- 32 bits encoder ----------------------------------- 
WINCONSDK_API long i8090_GET_ENCODER32(unsigned char cardNo, unsigned char axis);
WINCONSDK_API void i8090_ENCODER32_ISR(unsigned char cardNo);
WINCONSDK_API void i8090_RESET_ENCODER32(unsigned char cardNo, unsigned char axis);

WINCONSDK_API unsigned char i8090_GET_INDEX(unsigned char cardNo);                  

#endif // __i8090_H__