#ifndef __i8091_H__

#define __i8091_H__

#ifdef WINCONSDK_EXPORTS
#define WINCONSDK_API extern "C" __declspec(dllexport)
#else
#define WINCONSDK_API extern "C" __declspec(dllimport)
#endif
                                                 
#define YES          1
#define NO           0

#define READY        0
#define BUSY         1
  
#define ON           1
#define OFF          0

#define CW_CCW       0
#define PULSE_DIR    1

#define NORMAL_DIR   0
#define REVERSE_DIR  1

#define FW           0
#define BW           1
#define CW           0
#define CCW          1
#define X_axis       1
#define Y_axis       2 
#define Z_axis       3            

//------------Setting Command------------------------------------------------
WINCONSDK_API unsigned char i8091_REGISTRATION(unsigned char cardNo, int slot);
//----------------------------------------------------
WINCONSDK_API void          i8091_RESET_SYSTEM(unsigned char cardNo); 
WINCONSDK_API void          i8091_SET_VAR(unsigned char cardNo,
                            unsigned char set_DDA_cycle,
                            unsigned char set_Acc_Dec,
                            unsigned int set_Low_Speed,
                            unsigned int set_High_Speed);
WINCONSDK_API void          i8091_SET_DEFDIR(unsigned char cardNo,
                               unsigned char defdirX,
                               unsigned char defdirY);
WINCONSDK_API void          i8091_SET_MODE(unsigned char cardNo,
                             unsigned char modeX,
                             unsigned char modeY);
WINCONSDK_API void          i8091_SET_SERVO_ON(unsigned char cardNo,
                                 unsigned char sonX,
                                 unsigned char sonY);
WINCONSDK_API void          i8091_SET_NC(unsigned char cardNo, unsigned char sw);
//----------------------------------------------------
WINCONSDK_API void          i8091_STOP_X(unsigned char cardNo);
WINCONSDK_API void          i8091_STOP_Y(unsigned char cardNo);
WINCONSDK_API void          i8091_STOP_ALL(unsigned char cardNo);
WINCONSDK_API void          i8091_EMG_STOP(unsigned char cardNo);
//----------------------------------------------------
WINCONSDK_API void          i8091_LSP_ORG(unsigned char cardNo,
                            unsigned char DIR,
                            unsigned char AXIS);
WINCONSDK_API void          i8091_HSP_ORG(unsigned char cardNo,
                            unsigned char DIR,
                            unsigned char AXIS);
WINCONSDK_API void          i8091_LSP_PULSE_MOVE(unsigned char cardNo,
                                   unsigned char AXIS,
                                   long pulseN);
WINCONSDK_API void          i8091_HSP_PULSE_MOVE(unsigned char cardNo,
                                   unsigned char AXIS,
                                   long pulseN);
WINCONSDK_API void          i8091_LSP_MOVE(unsigned char cardNo,
                             unsigned char DIR,
                             unsigned char AXIS);
WINCONSDK_API void          i8091_HSP_MOVE(unsigned char cardNo,
                             unsigned char DIR,
                             unsigned char AXIS);
WINCONSDK_API void          i8091_CSP_MOVE(unsigned char cardNo,
                             unsigned char DIR,
                             unsigned char AXIS,
                             unsigned int  move_speed);
WINCONSDK_API void          i8091_SLOW_DOWN(unsigned char cardNo,
                              unsigned char AXIS);
WINCONSDK_API void          i8091_SLOW_STOP(unsigned char cardNo,
                              unsigned char AXIS);        
//------------------------------------------------------------------------                              
WINCONSDK_API void          i8091_INTP_PULSE(unsigned char cardNo,
                               int Xpulse, int Ypulse);
WINCONSDK_API void          i8091_INTP_LINE(unsigned char cardNo,
                              long Xpulse, long Ypulse);
//------------------------------------------------------------------------
WINCONSDK_API void          i8091_INTP_LINE02(unsigned char cardNo,
                                 long x,long y,
                                 unsigned int speed,
                                 unsigned char acc_mode);
WINCONSDK_API void          i8091_INTP_CIRCLE02(unsigned char cardNo,
                           long x,
                           long y,
                           unsigned char dir,
                           unsigned int speed,
                           unsigned char acc_mode);
WINCONSDK_API void          i8091_INTP_ARC02(unsigned char cardNo,
                        long x,
                        long y,
                        long R,
                        unsigned char dir,
                        unsigned int speed,
                        unsigned char acc_mode);
WINCONSDK_API unsigned char i8091_INTP_STOP();
//----------------------------------------------------
WINCONSDK_API unsigned char i8091_LIMIT_X(unsigned char cardNo);
WINCONSDK_API unsigned char i8091_LIMIT_Y(unsigned char cardNo);
//----------------------------------------------------
WINCONSDK_API void          i8091_WAIT_X(unsigned char cardNo);
WINCONSDK_API void          i8091_WAIT_Y(unsigned char cardNo);
//----------------------------------------------------
WINCONSDK_API unsigned char i8091_IS_X_STOP(unsigned char cardNo);
WINCONSDK_API unsigned char i8091_IS_Y_STOP(unsigned char cardNo);

//=============== add for User Delay 2006/04/21======================
WINCONSDK_API unsigned char i8091_IS_X_STOP_DELAY(unsigned char cardNo,unsigned char wT);
WINCONSDK_API unsigned char i8091_IS_Y_STOP_DELAY(unsigned char cardNo,unsigned char wT);

#endif // __i8091_H__
